<?php

namespace IdelibreApiPhp\Tests\Api;


use DateTime;
use IdelibreApiPhp\Api\Exception\IdelibreException;
use IdelibreApiPhp\Api\v2\SittingWrapper;
use IdelibreApiPhp\Client;
use IdelibreApiPhp\Enum\ApiPath;
use IdelibreApiPhp\Model\Annex;
use IdelibreApiPhp\Model\Api\OtherdocApi;
use IdelibreApiPhp\Model\Api\ProjectApi;
use IdelibreApiPhp\Model\Api\UserApi;
use IdelibreApiPhp\Model\Convocation;
use IdelibreApiPhp\Model\File;
use IdelibreApiPhp\Model\Project;
use IdelibreApiPhp\Model\Reminder;
use IdelibreApiPhp\Model\Sitting;
use IdelibreApiPhp\Model\Type;
use IdelibreApiPhp\Model\User;
use IdelibreApiPhp\Service\MultipartManager;
use IdelibreApiPhp\Tests\Mocker\ClientMock;
use PHPUnit\Framework\MockObject\Exception;
use PHPUnit\Framework\TestCase;
use Psr\Http\Client\ClientExceptionInterface;
use Symfony\Component\PropertyInfo\Extractor\ReflectionExtractor;
use Symfony\Component\Serializer\Encoder\JsonEncoder;
use Symfony\Component\Serializer\Exception\ExceptionInterface;
use Symfony\Component\Serializer\Normalizer\AbstractNormalizer;
use Symfony\Component\Serializer\Normalizer\ArrayDenormalizer;
use Symfony\Component\Serializer\Normalizer\DateTimeNormalizer;
use Symfony\Component\Serializer\Normalizer\GetSetMethodNormalizer;
use Symfony\Component\Serializer\Normalizer\ObjectNormalizer;
use Symfony\Component\Serializer\Serializer;
use function Symfony\Component\String\s;

class SittingWrapperTest extends TestCase
{

    private ClientMock $clientMock;
    private Serializer $serializer;
    private UserApi $userApi;

    protected function setUp(): void
    {
        parent::setUp(); // TODO: Change the autogenerated stub
        $this->clientMock = new ClientMock(Client::class);

        $this->multipartManager = new MultipartManager();
        $objectNormalizer = new ObjectNormalizer(null, null, null, new ReflectionExtractor(), null, null, [
            AbstractNormalizer::CIRCULAR_REFERENCE_HANDLER => function ($object) {
                return $object->getId();
            },
        ]);
        $getSetNormalizer = new GetSetMethodNormalizer();
        $dateTimeZoneNormalizer = new DateTimeNormalizer([DateTimeNormalizer::TIMEZONE_KEY => 'UTC']);
        $this->serializer = new Serializer(
            [$objectNormalizer, $getSetNormalizer, new ArrayDenormalizer(), $dateTimeZoneNormalizer],
            [new JsonEncoder()],
        );
        $this->userApi = $this->clientMock->isApiUser();

    }

    /**
     * @throws Exception
     * @throws ClientExceptionInterface
     * @throws \DateMalformedStringException
     */
    public function testGetAll()
    {
        $apiResponse ='[
            {"id":"ea3ecb60-8995-40ff-8c8a-c591492c810e","name":"Test remote","date":"2024-07-11T12:00:00+00:00","isArchived":false,"isRemoteAllowed":true,"updatedAt":"2024-09-09T13:33:03+00:00","isMandatorAllowed":true},
            {"id":"d8e550ab-c92b-4df0-921a-3117ea3a2e09","name":"Reunion exceptionnel","date":"2024-09-09T22:50:00+00:00","isArchived":false,"isRemoteAllowed":true,"updatedAt":"2024-09-10T13:36:51+00:00","isMandatorAllowed":true}]'
        ;

        $structureId = $this->userApi->getStructure()->getId();
        $clientMock = $this->clientMock->mockClient('get', sprintf(ApiPath::BASE_API_V2_PATH . '/sittings', $structureId), $apiResponse);

        $expected = [];
        foreach (json_decode($apiResponse, true) as $sitting) {
            $expected[] = $this->serializer->denormalize($sitting, Sitting::class, 'json');
        }

        $sittingWrapper = new SittingWrapper($clientMock);
        $sittings = $sittingWrapper->getAll();

        $this->assertEquals($expected[0]->getName(), $sittings[0]->getName());
        $this->assertInstanceOf(Sitting::class, $sittings[0]);
        $this->assertCount(2, $sittings);
    }

    /**
     * @throws \DateMalformedStringException
     * @throws ClientExceptionInterface
     * @throws Exception
     */
    public function testGetOne()
    {
        $apiResponse ='{"id":"724c6aa-d9a8-4158-bb12-0143971d3353","name":"Conseil municipal","date":"2022-10-10 18:30","isArchived":false,"revision":0,"place":"Salle du conseil","createdAt":"2022-10-10 10:00","type":{"id":"724c6aa-d91a-4158-bb12-0732971d3353","name":"Conseil Municipal"},"convocationFile":{"id":"724c6aa-dabc3-4158-bb12-0732971d3353","size":23456,"name":"convocationauConseil.pdf"},"invitationFile":{"id":"724c6bb-da243-4158-bb12-0732971d3353","size":23412,"name":"invitationauConseil.pdf"},"comelusId":"724c6bb-12345-4158-bb12-0732971d3353","reminder":{"id":"724c6bb-12345-4158-6543-0732971d3353","duration":60,"isActive":true},"isRemoteAllowed":true}';

        $structureId = $this->userApi->getStructure()->getId();
        $sittingId = json_decode($apiResponse, true)['id'];
        $clientMock = $this->clientMock->mockClient('get', sprintf(ApiPath::BASE_API_V2_PATH . '/sittings/' . $sittingId, $structureId), $apiResponse);

        $expected = $this->serializer->deserialize($apiResponse, Sitting::class, 'json');

        $sittingWrapper = new SittingWrapper($clientMock);
        $sitting = $sittingWrapper->getOne($sittingId);

        $this->assertInstanceOf(Sitting::class, $sitting);
        $this->assertEquals($expected->getName(), $sitting->getName());
        $this->assertEquals($expected->getInvitationFile()->getId(), $sitting->getInvitationFile()->getId());
        $this->assertEquals($expected->getReminder()->getId(), $sitting->getReminder()->getId());
        $this->assertEquals($expected->getConvocationFile()->getId(), $sitting->getConvocationFile()->getId());
    }

    /**
     * @throws \DateMalformedStringException
     * @throws ClientExceptionInterface
     * @throws Exception
     */
    public function testGetAllConvocations()
    {
        $apiResponse ='[
            {"id":"bc5f7b0b-06af-40c3-b1e5-9dbaeb01a18b","isRead":false,"isActive":false,"isEmailed":false,
                "user":{"id":"fa43f2e5-41bc-45db-a9b8-79e3b57fc77a","username":"p.dumontet-elu@libriciel","firstName":"Pierre","lastName":"Dumontet",
                "role":{"name":"Actor"},
                "deputy":{"id":"2eb54dd3-eb64-413e-9b09-91155ffbdf61","username":"j.parish-suppleant@libriciel","firstName":"Jules","lastName":"Parish",
                    "role":{"name":"Deputy"},
                    "deputy":null}},
                "sentTimestamp":null,
                "receivedTimestamp":null,
                "category":"convocation",
                "attendance":"","deputy":null,
                "mandator":null
            },
            {"id":"dc2dd7e2-59ae-4c93-ac4a-9b8e06e28ded","isRead":false,"isActive":false,"isEmailed":false,"user":{"id":"9f7f6f46-739a-4ae2-a30b-c65b298c5cfc","username":"c.dupont-admin@libriciel","firstName":"camille","lastName":"Dupont","role":{"name":"Admin"},"deputy":null},"sentTimestamp":null,"receivedTimestamp":null,"category":"invitation","attendance":"","deputy":null,"mandator":null},
            {"id":"46c6b059-1a1c-4630-b79f-e277115f7c04","isRead":false,"isActive":false,"isEmailed":false,"user":{"id":"2eb54dd3-eb64-413e-9b09-91155ffbdf61","username":"j.parish-suppleant@libriciel","firstName":"Jules","lastName":"Parish","role":{"name":"Deputy"},"deputy":null},"sentTimestamp":null,"receivedTimestamp":null,"category":"delegation","attendance":"","deputy":null,"mandator":null},{"id":"f39f0d13-2eb0-4f84-adee-d9957cc99967","isRead":false,"isActive":false,"isEmailed":false,"user":{"id":"15f2f5a1-689b-40a9-b8e3-83efabca4d30","username":"voxad@libriciel","firstName":"Ann","lastName":"Shaw","role":{"name":"Guest"},"deputy":null},"sentTimestamp":null,"receivedTimestamp":null,"category":"invitation","attendance":"","deputy":null,"mandator":null}]'
           ;


        $structureId = $this->userApi->getStructure()->getId();
        $sittingId = 'd86ee5fd-78a1-4b20-9e2a-921be09954d1';

        $clientMock = $this->clientMock->mockClient('get', sprintf(ApiPath::BASE_API_V2_PATH . '/sittings/' . $sittingId . '/convocations', $structureId), $apiResponse);

        $expected = [];
        foreach (json_decode($apiResponse, true) as $convocation) {

            if ($convocation['sentTimestamp']) {
                $convocation['sentTimestamp'] = new DateTime($convocation['sentTimestamp']);
            }
            if ($convocation['receivedTimestamp']) {
                $convocation['receivedTimestamp'] = new DateTime($convocation['receivedTimestamp']);
            }

            $expected[] = $this->serializer->denormalize($convocation, Convocation::class, 'json');
        }


        $sittingWrapper = new SittingWrapper($clientMock);
        $response = $sittingWrapper->getAllConvocations($sittingId);

        $this->assertCount(4, $response);
        $this->assertEquals($expected[0]->getUser()->getId(), $response[0]->getUser()->getId());
        $this->assertEquals($expected[0]->getUser()->getUsername(), $response[0]->getUser()->getUsername());
        foreach ($response as $convocation) {
            $this->assertInstanceOf(Convocation::class, $convocation);
        }
    }

    /**
     * @throws Exception
     * @throws ClientExceptionInterface
     */
    public function testGetAllProject()
    {
        $apiResponse = '[
            {"id":"fa851e42-880f-4a4d-86b7-3c61801b6e0c","name":"Projet-1","rank":0,"file":{"id":"f18b5253-8843-4b2e-a150-ce29d554eee0","name":"Projet-1.pdf"},"theme":{"id":"0887ecd9-ab31-4581-b7d1-342e7489c8c8","name":"Sous-th\u00e8me 1.1","fullName":"Th\u00e8me principal 1, Sous-th\u00e8me 1.1"},"reporter":[],"annexes":[{"id":"47757375-573d-4f88-ba8a-47fc6176df28","rank":0,"file":{"id":"3ee9fa62-e5d0-4831-b700-0822242a46fd","name":"Convocation.pdf"},"title":"Convocation"},{"id":"bea4a42d-e9f7-44c2-aae6-1fd2affe5bc9","rank":1,"file":{"id":"d05d1daf-2119-4704-bf47-318fe0617f1c","name":"Invitation.pdf"},"title":"Invitation"}]},
            {"id":"87b76c55-d4e9-41a0-9c9a-c9d2f44db0fd","name":"Projet-2","rank":1,"file":{"id":"6bc0db7e-d91a-4493-a1d3-96ef670be500","name":"Projet-2.pdf"},"theme":null,"reporter":null,"annexes":[]}
        ]';

        $structureId = $this->userApi->getStructure()->getId();
        $sittingId = 'd86ee5fd-78a1-4b20-9e2a-921be09954d1';
        $clientMock = $this->clientMock->mockClient('get', sprintf(ApiPath::BASE_API_V2_PATH . '/sittings/' . $sittingId . '/projects', $structureId), $apiResponse);

        $expected = [];
        foreach (json_decode($apiResponse, true) as $project) {

            if ($project['annexes']){
                $annexes = [];
                foreach ($project['annexes'] as $annex){
                    if ($annex['file']){
                        $annex['file'] = $this->serializer->denormalize($annex['file'], File::class, 'json');
                    }

                    $annex = $this->serializer->denormalize($annex, Annex::class, 'json');
                    $annexes[] = $annex;
                }
            }

            if (isset($project['reporter'])) {
                $project['reporter'] = $this->serializer->denormalize($project['reporter'], User::class, 'json');
            }

            $expected[] = $this->serializer->denormalize($project, Project::class, 'json');
        }


        $sittingWrapper = new SittingWrapper($clientMock);
        $response = $sittingWrapper->getAllProjects($sittingId);

        $this->assertCount(2, $response);
        $this->assertEquals($expected[0]->getName(), $response[0]->getName());
        foreach ($response as $project) {
            $this->assertInstanceOf(Project::class, $project);
        }
    }

    /**
     * @throws Exception
     */
    public function testSendAllConvocation()
    {
        $apiResponse = '{"message" : "success"}';

        $structureId = $this->userApi->getStructure()->getId();
        $sittingId = 'd86ee5fd-78a1-4b20-9e2a-921be09954d1';
        $clientMock = $this->clientMock->mockClient('get', sprintf(ApiPath::BASE_API_V2_PATH . '/sittings/' . $sittingId . '/convocations/sendAll', $structureId), $apiResponse);

        $sittingWrapper = new SittingWrapper($clientMock);
        $response = $sittingWrapper->sendAll($sittingId);

        $this->assertEquals('success', $response['message']);
    }

    /**
     * @throws Exception
     * @throws ExceptionInterface
     * @throws ClientExceptionInterface
     */
    public function testAddOtherdocs() {

        $file1 = (new File())
            ->setId('2f653a0b-943c-4681-bb52-bafe0a3b1aa1')
            ->setName('file1.pdf')
            ->setSize(123456)
            ->setPath( __DIR__ . '/../../tests/Resources/invitation.pdf')
        ;

        $document1 =( new OtherdocApi())
            ->setId('e481783a-7f75-41be-902d-f1ad48d9f11d')
            ->setName('Document 1')
            ->setLinkedFileKey($file1->getId())
            ->setSize(123456);

        $file2 = (new File())
            ->setId('814d7684-b1be-4f85-bac0-1062e99fce84')
            ->setName('file2.pdf')
            ->setSize(123456)
            ->setPath(__DIR__ . '/../../tests/Resources/invitation.pdf')
        ;

        $document2 = (new OtherdocApi())
            ->setId('c3a53d29-1925-423c-84ce-47dd2ab76b01')
            ->setName('Document 2')
            ->setLinkedFileKey($file2->getId())
            ->setSize(123456);


        $otherdocs = [$this->serializer->normalize($document1), $this->serializer->normalize($document2)];
        $files = [$this->serializer->normalize($file1), $this->serializer->normalize($file2)];

        $apiResponse = '[
            {"id":"c2a5e2db-07fb-42e3-b193-f0975d8a8831","name":"Document 1","rank":1,"file":{"id":"be59ba23-75aa-4737-afc8-449c2d80e562","name":"projet_1.pdf"}},
            {"id":"4ba1bab8-607d-430a-9fb8-1a73c847bbce","name":"Document 2","rank":2,"file":{"id":"c6b6f905-b81e-4c42-8d81-306a7fb65c11","name":"projet_2.pdf"}}
        ]';

        $multipartApiResponse = $this->serializer->decode($apiResponse, 'json');

        $structureId = $this->userApi->getStructure()->getId();
        $sittingId = 'd86ee5fd-78a1-4b20-9e2a-921be09954d1';

        $clientMock = $this->clientMock->mockMultipartClient(
            'postMultipart',
            sprintf(ApiPath::BASE_API_V2_PATH . '/sittings/' . $sittingId . '/otherdocs', $structureId),
            $multipartApiResponse
        );

        $sittingWrapper = new SittingWrapper($clientMock);
        $response = $sittingWrapper->addOtherdocs($sittingId, $otherdocs, $files);

        $expected = [];
        foreach (json_decode($apiResponse, true) as $otherdoc) {
            $expected[] = $this->serializer->denormalize($otherdoc, OtherdocApi::class, 'json');
        }

        $this->assertEquals($expected, $response);
    }

    /**
     * @throws ExceptionInterface
     * @throws ClientExceptionInterface
     * @throws Exception
     */
    public function testAddProjectsNoAnnexes()
    {
        $file1 = (new File())
            ->setId('2f653a0b-943c-4681-bb52-bafe0a3b1aa1')
            ->setName('file1.pdf')
            ->setSize(123456)
            ->setPath(__DIR__ . '/../../tests/Resources/invitation.pdf')
        ;

        $project1 =( new ProjectApi())
            ->setId('e481783a-7f75-41be-902d-f1ad48d9f11d')
            ->setName('Projet 1')
            ->setLinkedFileKey($file1->getId())
            ->setSize(123456);

        $file2 = (new File())
            ->setId('814d7684-b1be-4f85-bac0-1062e99fce84')
            ->setName('file2.pdf')
            ->setSize(123456)
            ->setPath(__DIR__ . '/../../tests/Resources/invitation.pdf');

        $project2 =( new ProjectApi())
            ->setId('e481783a-7f75-41be-902d-f1ad48d9f11d')
            ->setName('Projet 2')
            ->setLinkedFileKey($file2->getId())
            ->setSize(123456);


        $projects = [$this->serializer->normalize($project1), $this->serializer->normalize($project2)];
        $files = [$this->serializer->normalize($file1), $this->serializer->normalize($file2)];

        $apiResponse = '[
            {"id":"c2a5e2db-07fb-42e3-b193-f0975d8a8831","name":"Project 1","rank":1,"file":{"id":"be59ba23-75aa-4737-afc8-449c2d80e562","name":"projet_1.pdf"}},
            {"id":"4ba1bab8-607d-430a-9fb8-1a73c847bbce","name":"Project 2","rank":2,"file":{"id":"c6b6f905-b81e-4c42-8d81-306a7fb65c11","name":"projet_2.pdf"}}
        ]';

        $sittingId = 'd86ee5fd-78a1-4b20-9e2a-921be09954d1';
        $multipartApiResponse = $this->serializer->decode($apiResponse, 'json');

        $clientMock = $this->clientMock->mockMultipartClient(
            'postMultipart',
            sprintf(ApiPath::BASE_API_V2_PATH . '/sittings/' . $sittingId . '/projects', $this->userApi->getStructure()->getId()),
            $multipartApiResponse
        );



        $sittingWrapper = new SittingWrapper($clientMock);
        $response = $sittingWrapper->addProjects($sittingId, $projects, $files);

        $expected = [];
        foreach (json_decode($apiResponse, true) as $project) {
            $expected[] = $this->serializer->denormalize($project, ProjectApi::class, 'json');
        }

        $this->assertInstanceOf(ProjectApi::class, $response[0]);
        $this->assertEquals($expected, $response);

    }

    /**
     * @throws \Http\Client\Exception
     * @throws ClientExceptionInterface
     * @throws Exception
     * @throws ExceptionInterface
     */
    public function testAddProjectsWithAnnexes()
    {
        $file1 = (new File())
            ->setId('2f653a0b-943c-4681-bb52-bafe0a3b1aa1')
            ->setName('file1.pdf')
            ->setSize(123456)
            ->setPath(__DIR__ . '/../../tests/Resources/invitation.pdf')
        ;

        $project1 =( new ProjectApi())
            ->setId('e481783a-7f75-41be-902d-f1ad48d9f11d')
            ->setName('Projet 1')
            ->setLinkedFileKey($file1->getId())
            ->setSize(123456);

        $file2 = (new File())
            ->setId('814d7684-b1be-4f85-bac0-1062e99fce84')
            ->setName('file2.pdf')
            ->setSize(123456)
            ->setPath(__DIR__ . '/../../tests/Resources/invitation.pdf');

        $project2 =( new ProjectApi())
            ->setId('e481783a-7f75-41be-902d-f1ad48d9f11d')
            ->setName('Projet 2')
            ->setLinkedFileKey($file2->getId())
            ->setSize(123456);


        $projects = [$this->serializer->normalize($project1), $this->serializer->normalize($project2)];
        $files = [$this->serializer->normalize($file1), $this->serializer->normalize($file2)];

        $apiResponse = '[{"id":"724c6bb-da243-4158-bb12-0732971d3353","name":"Projet de création de ...","rank":0,"file":{"id":"724c6bb-da243-4158-bb12-073a4b1d3353","size":23456,"name":"projetcreation.pdf"},"theme":{"id":"724c6bb-da243-4158-bb12-0732971da567","name":"aménagement"},"reporter":{"id":"724c6bb-da725-4158-bb12-0732971d3353"},"annexes":[{"id":"724c6bb-da243-4158-bb12-0732971d3353","rank":0,"file":{"id":"724c6bb-da243-4158-aaaaa-0732971d3353","size":12345,"name":"annex1.pdf"}}]}]';

        $sittingId = 'd86ee5fd-78a1-4b20-9e2a-921be09954d1';
        $multipartApiResponse = $this->serializer->decode($apiResponse, 'json');

        $clientMock = $this->clientMock->mockMultipartClient(
            'postMultipart',
            sprintf(ApiPath::BASE_API_V2_PATH . '/sittings/' . $sittingId . '/projects', $this->userApi->getStructure()->getId()),
            $multipartApiResponse
        );



        $sittingWrapper = new SittingWrapper($clientMock);
        $response = $sittingWrapper->addProjects($sittingId, $projects, $files);

        $expected = [];
        foreach (json_decode($apiResponse, true) as $project) {
            $expected[] = $this->serializer->denormalize($project, ProjectApi::class, 'json');
        }

        $this->assertInstanceOf(ProjectApi::class, $response[0]);
        $this->assertEquals($expected, $response);

    }

    /**
     * @throws ClientExceptionInterface
     * @throws Exception
     * @throws ExceptionInterface
     * @throws IdelibreException
     */
    public function testCreateSitting()
    {
        $type = (new Type())
            ->setId("724c6aa-d91a-4158-bb12-0732971d3389")
            ->setName('Conseil Municipal');

        $convocationFile = (new File())
            ->setId("724c6aa-dabc3-4158-bb12-0732971d3353")
            ->setName('convocationauConseil.pdf')
            ->setPath(__DIR__ . '/../../tests/Resources/convocation.pdf');

        $invitationFile = (new File())
            ->setId("724c6aa-dabc3-4158-bb12-0732971d3343")
            ->setName('invitationauConseil.pdf')
            ->setPath(__DIR__ . '/../../tests/Resources/invitation.pdf');

        $reminder = (new Reminder())
            ->setId("724c6aa-dabc3-4158-bb12-0732971d3364")
            ->setDuration(60)
            ->setIsActive(true);


        $sitting = (new Sitting())
            ->setName($type->getName())
            ->setDate(new \DateTime('2022-10-10 18:30'))
            ->setPlace('Salle du conseil')
            ->setType($type)
            ->setConvocationFile($convocationFile)
            ->setInvitationFile($invitationFile)
            ->setReminder($reminder)
            ->setIsRemoteAllowed(true)
            ->setIsMandatorAllowed(true);

        $apiResponse = '[{"id":"724c6aa-d9a8-4158-bb12-0143971d3353","name":"Conseil municipal","date":"2022-10-10 18:30","isArchived":false,"revision":0,"place":"Salle du conseil","createdAt":"2022-10-10 10:00","type":{"id":"724c6aa-d91a-4158-bb12-0732971d3353","name":"Conseil Municipal"},"convocationFile":{"id":"724c6aa-dabc3-4158-bb12-0732971d3353","size":23456,"name":"convocationauConseil.pdf"},"invitationFile":{"id":"724c6bb-da243-4158-bb12-0732971d3353","size":23412,"name":"invitationauConseil.pdf"},"comelusId":"724c6bb-12345-4158-bb12-0732971d3353","reminder":{"id":"724c6bb-12345-4158-6543-0732971d3353","duration":60,"isActive":true},"isRemoteAllowed":false}]';
        $multipartResponse = $this->serializer->decode($apiResponse, 'json');

        $structureId = $this->userApi->getStructure()->getId();

        $clientMock = $this->clientMock->mockMultipartClient(
            'postMultipart',
            sprintf(ApiPath::BASE_API_V2_PATH . '/sittings', $structureId),
            $multipartResponse
        );

        $sittingWrapper = new SittingWrapper($clientMock);
        $response = $sittingWrapper->create($sitting);

        $this->assertInstanceOf(Sitting::class, $response);
    }





}
